 
/****************************************************************************
  SECTION 	Include
****************************************************************************/

#include "TCPIP Stack/TCPIP.h"
#if defined(STACK_USE_HTTP2_SERVER)


/****************************************************************************
  SECTION	Define
****************************************************************************/
#define __HTTPAPP_C


/****************************************************************************
  SECTION 	Authorization Handlers
****************************************************************************/
int lighton;
int lightoff;
int MAX_PRODUCTS = 1000;
int check;
struct x{
	char firstname[100];
	char lastname[30];
	char middlename[20];
	char lg[20];
};
struct x profile[10];
/*****************************************************************************
  FUNCTION	BYTE HTTPNeedsAuth(BYTE* cFile)

  This function is used by the stack to decide if a page is access protected.
  If the function returns 0x00, the page is protected, if returns 0x80, no 
  authentication is required
*****************************************************************************/
#if defined(HTTP_USE_AUTHENTICATION)
BYTE HTTPNeedsAuth(BYTE* cFile)
{
	//	If you want to restrict the access to some page, include it in the folder "protect"
	//	here you can change the folder, or add others
	if(memcmppgm2ram(cFile, (ROM void*)"protect", 7) == 0)
		return 0x00;		// Authentication will be needed later

	// You can match additional strings here to password protect other files.
	// You could switch this and exclude files from authentication.
	// You could also always return 0x00 to require auth for all files.
	// You can return different values (0x00 to 0x79) to track "realms" for below.

	return 0x80;			// No authentication required
}
#endif

/*****************************************************************************
  FUNCTION	BYTE HTTPCheckAuth(BYTE* cUser, BYTE* cPass)
	
  This function checks if username and password inserted are acceptable

  ***************************************************************************/
#if defined(HTTP_USE_AUTHENTICATION)
BYTE HTTPCheckAuth(BYTE* cUser, BYTE* cPass)
{
	if(strcmppgm2ram((char *)cUser,(ROM char *)"admin") == 0
		&& strcmppgm2ram((char *)cPass, (ROM char *)"flyport") == 0)
		return 0x80;		// We accept this combination
	
	// You can add additional user/pass combos here.
	// If you return specific "realm" values above, you can base this 
	//   decision on what specific file or folder is being accessed.
	// You could return different values (0x80 to 0xff) to indicate 
	//   various users or groups, and base future processing decisions
	//   in HTTPExecuteGet/Post or HTTPPrint callbacks on this value.
	
	return 0x00;			// Provided user/pass is invalid
}
#endif

/****************************************************************************
  SECTION	GET/POST Form Handlers
****************************************************************************/
  
/****************************************************************************
  FUNCTION	HTTP_IO_RESULT HTTPExecuteGet(void)
	
  This function processes every GET request from the pages.
*****************************************************************************/
HTTP_IO_RESULT HTTPExecuteGet(void)
{
	BYTE *ptr;
	BYTE filename[20];
	
	// Load the file name
	// Make sure BYTE filename[] above is large enough for your longest name
	MPFSGetFilename(curHTTP.file, filename, 20);

	// If it's the LED updater file
	if(!memcmppgm2ram(filename, "flyport.cgi", 8))
	{
		// Determine which LED to toggle
		ptr = HTTPGetROMArg(curHTTP.data, (ROM BYTE *)"out");
		// Toggle the specified LED
		switch(*ptr) 
		{
		
			case '0':
				IOPut(o1,toggle);
				break;
			case '1':
				IOPut(o2,toggle);
				break;
			case '2':
				IOPut(o3,toggle);
				break;
			case '3':
				IOPut(o4,toggle);
				break;
			case '4':
				IOPut(o5,toggle);
				break;
		}
		
	}
	
	return HTTP_IO_DONE;
}

/*return values*/
void HTTPPrint_hostname(void)
{
	TCPPutString(sktHTTP, AppConfig.NetBIOSName);
}
/*void HTTPPrint_lightson()
{
	if(lighton == 1)
		TCPPutROMString(sktHTTP, (ROM BYTE*)"checked");
	else
		TCPPutROMString(sktHTTP,(ROM BYTE*) "");

}
void HTTPPrint_lightsoff()
{
	if(lightoff == 1)
		TCPPutROMString(sktHTTP,(ROM BYTE*) "checked");
	else 
		TCPPutROMString(sktHTTP,(ROM BYTE*) "");

}*/
void HTTPPrint_fname()
{
	TCPPutString(sktHTTP, (BYTE*)profile[0].firstname);
}

void HTTPPrint_mname()
{
	TCPPutString(sktHTTP, (BYTE*)profile[0].middlename);
}

void HTTPPrint_lname()
{
	TCPPutString(sktHTTP, (BYTE*)profile[0].lastname);
}
void HTTPPrint_selected1()
{
	if(IOGet(o1) == 1)
		TCPPutString(sktHTTP, (BYTE*)"selected");
	else
		TCPPutString(sktHTTP, (BYTE*)"");
}
void HTTPPrint_selected0()
{
	if(IOGet(o1) == 1)
		TCPPutString(sktHTTP, (BYTE*)"");
	else
		TCPPutString(sktHTTP, (BYTE*)"selected");
}
void HTTPPrint_out(WORD num)
{
	switch(num)
	{
		case 0:
			num = IOGet(o1);
			break;
		case 1:
			num = IOGet(o2);
			break;
		case 2:
			num = IOGet(o3);
			break;
		case 3:
			num = IOGet(o4);
			break;
		case 4:
			num = IOGet(o5);
			break;
		default:
			num = 0;
	}

	// Print the output
	TCPPut(sktHTTP, (num?'1':'0'));
	return;
}

void HTTPPrint_in(WORD num)
{
	BYTE AN0String[8];
	WORD ADval;

	switch(num)
	{
		case 0:
			ADval = ADCVal(0);//(WORD)ADC1BUF0;
			uitoa(ADval, (BYTE*)AN0String);
			break;
		case 1:
			ADval = ADCVal(1);//(WORD)ADC1BUF1;
			uitoa(ADval, (BYTE*)AN0String);
			break;	
		case 2:
			ADval = ADCVal(2);//(WORD)ADC1BUF1;
			uitoa(ADval, (BYTE*)AN0String);
			break;	
		case 3:
			ADval = ADCVal(3);//(WORD)ADC1BUF1;
			uitoa(ADval, (BYTE*)AN0String);
			break;
		case 4:
			ADval = ADCVal(4);//(WORD)ADC1BUF1;
			uitoa(ADval, (BYTE*)AN0String);
			break;
	}

   	TCPPutString(sktHTTP, AN0String);
}

#ifdef HTTP_USE_POST
/****************************************************************************
  FUNCTION	HTTP_IO_RESULT HTTPExecutePost(void)
	
  This function processes every POST request from the pages. 
*****************************************************************************/
HTTP_IO_RESULT HTTPExecutePost(void)
{
	BYTE name[20], item;
	WORD len;
	
		// Load the file name
		MPFSGetFilename(curHTTP.file, name, 20);
		// Make sure it's the index.htm page
		if(strcmppgm2ram((char*)name,(ROM char*)"index.htm") != 0)
		return HTTP_IO_DONE;
		
		// Loop while data remains
		while(curHTTP.byteCount)
		{
			
			// Check for a complete variable
			len = TCPFind(sktHTTP, '&', 0, FALSE);
			if(len == 0xffff)
			{// Check if this is the last one
			if(TCPIsGetReady(sktHTTP) == curHTTP.byteCount)
			len = curHTTP.byteCount - 1;
			else // Wait for more data
			return HTTP_IO_NEED_DATA;
			}
			
			if(len > HTTP_MAX_DATA_LEN - 2)
			{// Make sure we don't overflow
			curHTTP.byteCount -= TCPGetArray(sktHTTP, NULL, len+1);
			continue;
			}
			len = TCPGetArray(sktHTTP,curHTTP.data, len+1);
			curHTTP.byteCount -= len;
			curHTTP.data[len] = '\0';
			HTTPURLDecode(curHTTP.data);
		
			// Figure out which variable it is
			if(memcmppgm2ram(curHTTP.data,(ROM void*)"firstname", 9) == 0)
			{// A name was found
				item = curHTTP.data[10] - '0';
				if(item > MAX_PRODUCTS)
				continue;
				memcpy((void*)profile[0].firstname,(void*)&curHTTP.data[10], 100);
			}
			else if(memcmppgm2ram(curHTTP.data,(ROM void*)"middlename", 10) == 0)
			{// A name was found
				item = curHTTP.data[11] - '0';
				if(item > MAX_PRODUCTS)
				continue;
				memcpy((void*)profile[0].middlename,(void*)&curHTTP.data[11], 30);
			}
			else if(memcmppgm2ram(curHTTP.data,(ROM void*)"lastname", 8) == 0)
			{// A name was found
				item = curHTTP.data[9] - '0';
				if(item > MAX_PRODUCTS)
				continue;
				memcpy((void*)profile[0].lastname,(void*)&curHTTP.data[9], 20);
			}
			else if(memcmppgm2ram(curHTTP.data,(ROM void*)"light", 5) == 0)
			{// A name was found
				item = curHTTP.data[6] - '0';
				if(item > MAX_PRODUCTS)
				continue;
				memcpy((void*)profile[0].lg,(void*)&curHTTP.data[6], 20);
			}
		}	
		
						
		return HTTP_IO_DONE;
}
#endif
#endif
